package com.steerinfo.meterwork.meterworkbeltxiaopi.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkbelttiminginfo.model.MeterWorkBeltTiminginfo;
import com.steerinfo.meterwork.meterworkbeltxiaopi.model.MeterWorkBeltXiaopi;
import com.steerinfo.meterwork.meterworkbeltxiaopi.service.IMeterWorkBeltXiaopiService;
import com.steerinfo.util.CommonPage;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkBeltXiaopi RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-11-06 11:04
 * 类描述
 * 修订历史：
 * 日期：2021-11-06
 * 作者：generator
 * 参考：
 * 描述：MeterWorkBeltXiaopi RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterworkbeltxiaopis")
public class MeterWorkBeltXiaopiController extends BaseRESTfulController {

    @Autowired
    IMeterWorkBeltXiaopiService meterWorkBeltXiaopiService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkbeltxiaopi:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkBeltXiaopi> list = meterWorkBeltXiaopiService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkbeltxiaopi:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkBeltXiaopi> list = meterWorkBeltXiaopiService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterWorkBeltXiaopi对象创建")
    @ApiImplicitParam(name = "meterWorkBeltXiaopi", value = "详细实体meterWorkBeltXiaopi", required = true, dataType = "MeterWorkBeltXiaopi")
    //@RequiresPermissions("meterworkbeltxiaopi:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkBeltXiaopi model){
        MeterWorkBeltXiaopi meterWorkBeltXiaopi = meterWorkBeltXiaopiService.add(model);
        return success(meterWorkBeltXiaopi);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkbeltxiaopi:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterWorkBeltXiaopi meterWorkBeltXiaopi = meterWorkBeltXiaopiService.getById(id);
        return success(meterWorkBeltXiaopi);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkBeltXiaopi信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterWorkBeltXiaopi", value = "详细实体meterWorkBeltXiaopi", required = true, dataType = "MeterWorkBeltXiaopi")
    })
    //@RequiresPermissions("meterworkbeltxiaopi:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkBeltXiaopi model){
        model.setId(id);
        MeterWorkBeltXiaopi meterWorkBeltXiaopi = meterWorkBeltXiaopiService.modify(model);
        return success(meterWorkBeltXiaopi);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkbeltxiaopi:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterWorkBeltXiaopiService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value = "C#端皮带秤校皮数据", notes = "根据MeterWorkBeltXiaopi对象创建")
    @ApiImplicitParam(name = "MeterWorkBeltXiaopi", value = "详细实体MeterWorkBeltXiaopi", required = true, dataType = "MeterWorkBeltXiaopi")
    @PostMapping(value = "/doQueryWf")
    public RESTfulResult doQueryWf(@RequestBody CommonPage<MeterWorkBeltXiaopi> model) {
        try {
            List<MeterWorkBeltXiaopi> no = meterWorkBeltXiaopiService.doQueryWf(model);
            return success(no);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "C#端入库秤实绩", notes = "根据MeterWorkBeltXiaopi对象创建")
    @ApiImplicitParam(name = "MeterWorkBeltXiaopi", value = "详细实体MeterWorkBeltXiaopi", required = true, dataType = "MeterWorkBeltXiaopi")
    @PostMapping(value = "/doAddWf")
    public RESTfulResult doAddWf(@RequestBody MeterWorkBeltXiaopi model) {
        try {
            int str =  meterWorkBeltXiaopiService.doAddWf(model);
            return success(str);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }
}
